import asyncdispatch, jester, json, osproc, tempfile

import ./configuration, ./core, private/util

settings:
  port = Port(8180)

type Worker = object
  process*: Process
  workingDir*: string

proc spawnWorker(req: RunRequest): Worker =
  let dir = mkdtemp()
  var args = @["run", req.projectName, req.stepName, "-r", req.buildRef, "-w", dir]
  if req.forceRebuild: args.add("-f")
  result = Worker(
    process: startProcess("strawboss", ".", args, loadEnv(), {poUsePath}),
    workingDir: dir)

proc start*(givenCfg: StrawBossConfig): void =

  var workers: seq[Worker] = @[]

  routes:
    get "/api/ping":
      resp $(%*"pong"), "application/json"

    get "/api/projects":
      resp $(%*[]), "application/json"

    post "/api/project/@projectName/@stepName/run/@buildRef?":
      workers.add(spawnWorker(RunRequest(
        projectName: @"projectName",
        stepName: @"stepName",
        buildRef: if @"buildRef" != "": @"buildRef" else: nil,
        forceRebuild: false)))  # TODO support this with optional query params

  runForever()
